# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://find-sec-bugs.github.io/bugs.htm
# yamllint enable
---
rules:
  - id: "kotlin_perm_rule-OverlyPermissiveFilePermissionInline"
    languages:
      - "kotlin"
    message: |
      Overly permissive file permission
    metadata:
      shortDescription: "Incorrect permission assignment for critical resource"
      cwe: "CWE-732"
      owasp:
        - "A5:2017-Broken Access Control"
        - "A01:2021-Broken Access Control"
      category: "security"
      confidence: "HIGH"
      security-severity: "MEDIUM"
    severity: "WARNING"

    patterns:
      - pattern-either:
          - pattern: "java.nio.file.Files.setPosixFilePermissions(..., java.nio.file.attribute.PosixFilePermissions.fromString(\"$PERM_STRING\"));"
          - pattern: |
              $PERMISSIONS = java.nio.file.attribute.PosixFilePermissions.fromString("$PERM_STRING");
              ...
              java.nio.file.Files.setPosixFilePermissions(..., $PERMISSIONS);
      - metavariable-regex:
          metavariable: "$PERM_STRING"
          regex: "[rwx-]{6}[rwx]{1,}"
